<?php

namespace Service\MigrationLogin;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;

class EntityManagers {

    public static function getEntityManagers($nrorg,$orgIdentityId){
        /** @var EntityManager $entityManagerIdentity */
        /** @var EntityManager $entityManagerSaas */
        /** @var EntityManager $entityManagerZmart */
        $entityManagerIdentity = InstanceManager::getInstance()->getService('entityManagerIdentity');
        $entityManagerSaas = InstanceManager::getInstance()->getService('entityManagerSaas');
        $entityManagerZmart = InstanceManager::getInstance()->getService('entityManagerZmart');

        $connectionSaas = InstanceManager::getInstance()->getParameter('connection_params_saas');
        $connectionName = 'USR_ORG_'.$nrorg;
        if($connectionSaas['user'] != $connectionName && $connectionSaas['dbname'] != $connectionName){
            throw new \Exception('Configuração do banco de destino com organização diferente de '.$connectionName);
        };
        $mongoHost = InstanceManager::getInstance()->getParameter('mongoHost');
        $mongoParams = array(
            'server' => $mongoHost,
            'port' => InstanceManager::getInstance()->getParameter('mongoPort'),
            'mongoOptions' => array()
        );

        $mongoHostIdentity = InstanceManager::getInstance()->getParameter('mongoHostIdentity');
        $mongoParamsIdentity = array(
            'server' => $mongoHostIdentity,
            'port' => InstanceManager::getInstance()->getParameter('mongoPortIdentity'),
            'mongoOptions' => array()
        );


        $mongoScript = new \Util\MongoDataBaseAlterations($mongoParams,$mongoParamsIdentity);
        $mongoScript->setOrgs($nrorg);
        $mongoScript->setRelatedIds(array($orgIdentityId => $nrorg));
        $dbName = $mongoScript->ORG_DB_PREFIX.$nrorg;
        $orgMongoManager = $mongoScript->buildManager($dbName);
        $allNameCollections = $orgMongoManager->getCollectionNames();

        echo "\n Criando usuario no mongo da organização...";
        $mongoScript->createDbUserPerNrorg();
        if(empty($allNameCollections)){
            //throw new \Exception('O banco do mongo de destino "'.$dbName.'" está vazio');


            echo "\n Clonando o banco antigo pra o novo ...";
            $time = $mongoScript->cloneDBName($mongoHostIdentity);
            echo "\n Clonado! tempo = $time";
            echo "\n Criando usuario no mongo ...";
            $mongoScript->createDbUser();

        }
        return array($entityManagerIdentity,$entityManagerSaas,$entityManagerZmart,$mongoScript);
    }

    /**
     * @return \Util\MongoDataBaseAlterations
     */
    public static function getMongo(){

        $mongoHost = InstanceManager::getInstance()->getParameter('mongoHost');
        $mongoParams = array(
            'server' => $mongoHost,
            'port' => InstanceManager::getInstance()->getParameter('mongoPort'),
            'mongoOptions' => array()
        );
        $mongoScript = new \Util\MongoDataBaseAlterations($mongoParams);
        return $mongoScript;
    }

    public static function getNewCode($nrorg){
        /** @var NewCode $newCodeSaas */
        $newCodeSaas = InstanceManager::getInstance()->getService('newCodeSaas');
        return $newCodeSaas;
    }
}