/* Tabela TABELA: TABELA DE TABELA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TABELA */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABELA,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_TABELA
AFTER DELETE OR INSERT OR UPDATE
ON TABELA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.NMTABELABD,'NULL') <> NVL(:OLD.NMTABELABD,'NULL') THEN
			V_DESC   := 'Nm Tabela ' || '' || NVL(:NEW.NMTABELABD,'' );
		END IF;
		IF NVL(:NEW.IDCRIADOTAB,'NULL') <> NVL(:OLD.IDCRIADOTAB,'NULL') THEN
		    V_DESC   := NVL(V_DESC,'') || ' ' || 'Id Criao Tabela ' || '' || NVL(:NEW.IDCRIADOTAB,'');
       		END IF;
		IF NVL(:NEW.DSTABELABD,'NULL') <> NVL(:OLD.DSTABELABD,'NULL') THEN
	            V_DESC   := NVL(V_DESC,'') || ' ' || 'Ds Tabela ' || '' || NVL(:NEW.DSTABELABD,'' );
		END IF;
		IF NVL(:NEW.IDUTCALQTORC,'NULL') <> NVL(:OLD.IDUTCALQTORC,'NULL') THEN
	 	    V_DESC   := NVL(V_DESC,'') || ' ' || 'Id Uti Calculo' || '' || NVL(:NEW.IDUTCALQTORC,'' );
		END IF;
      V_ITPESQ := :NEW.NMTABELABD;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Nm Tabela '         || '' || NVL(:NEW.NMTABELABD,'' )   || ' ' ||
                  'Id Criao Tabela ' || '' || NVL(:NEW.IDCRIADOTAB,'')   || ' ' ||
                  'Ds Tabela '         || '' || NVL(:NEW.DSTABELABD,'' )   || ' ' ||
                  'Id Uti Calculo'     || '' || NVL(:NEW.IDUTCALQTORC,'' );
      V_ITPESQ := :NEW.NMTABELABD;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Nm Tabela '         || '' || NVL(:OLD.NMTABELABD,'' )   || ' ' ||
                  'Id Criao Tabela ' || '' || NVL(:OLD.IDCRIADOTAB,'')   || ' ' ||
                  'Ds Tabela '         || '' || NVL(:OLD.DSTABELABD,'' )   || ' ' ||
                  'Id Uti Calculo'     || '' || NVL(:OLD.IDUTCALQTORC,'' );
      V_ITPESQ := :OLD.NMTABELABD;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND)
   VALUES
      ('TABELA',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_TABELA','5.20.001'); END;
/
