/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GROPERALMOX                                              */
/* Tabela : GROPERALMOX                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GROPERALMOX' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GROPERALMOX
GO

CREATE TRIGGER DTULTATU_GROPERALMOX
ON GROPERALMOX
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GROPERALMOX', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+
                                      'CDGRUPOPER='+ CDGRUPOPER+ ';' +'CDALMOXARIFE='+ CDALMOXARIFE+ ';',
                                      GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GROPERALMOX
      SET DTULTATUGRAL = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(GROPERALMOX.CDGRUPOPER,0)   = ISNULL(INSERTED.CDGRUPOPER,0)) AND
            (ISNULL(GROPERALMOX.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(GROPERALMOX.CDALMOXARIFE,0) = ISNULL(INSERTED.CDALMOXARIFE,0));

   END;
END;
GO


